using ETHZ.C0284H.Calculator.CalculatorNode.Visitor;

namespace ETHZ.C0284H.Calculator.CalculatorNode
{

	/// <summary>
	/// Operator "-"
	/// </summary>
	public sealed class MinusOperator:AbstractOperator
	{
		/// <summary>
		/// Minus Operator constructor
		/// </summary>
		public MinusOperator ():base("-")
		{}

		/// <summary>
		/// Implement double dispatch using this operator and the specific visitor passed as argument
		/// </summary>
		/// <param name="visitor">
		/// A <see cref="IVisitor"/>
		/// </param>
		public override void Accept(IVisitor visitor)
		{
		    if (visitor != null)
		    {
                visitor.VisitMinusOperator(this);		        
		    }
		}
	}		
}
