using System;
using System.Runtime.Serialization;

namespace ETHZ.C0284H.Calculator.Exceptions
{
    /// <summary>
    /// Represents the case when a requested instruct could not be found in a system. Typically, this occurs because of typos.
    /// </summary>
    [Serializable]
    public class MissingInstructException : Exception
    {
        public MissingInstructException() : this("Could not parse the instruct.")
        {
        }

        public MissingInstructException(string message) : base(message)
        {
        }

        public MissingInstructException(string message, Exception inner) : base(message, inner)
        {
        }

        protected MissingInstructException(
            SerializationInfo info,
            StreamingContext context) : base(info, context)
        {
        }
    }
}