﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using ETHZ.C0284H.Calculator.UI;
using NUnit.Framework;
using NUnit.Framework.Constraints;

namespace ETHZ.C0284H.Calculator
{
	[TestFixture()]
    public class ConsoleCalculatorTest
	{
        private string _testInput;
        private string _testOutput;
        private static readonly string s_newLine = Environment.NewLine;
		
		[Test]
		public void TestConsoleOperation()
		{
            _testInput = "10" + s_newLine 
                    + "5" + s_newLine 
                    + "+" + s_newLine 
                    + "evaluate" + s_newLine 
                    + "print" + s_newLine 
                    + "quit" + s_newLine;
            _testOutput = "#####15" + s_newLine 
                    + "#Console calculator quitting..." + s_newLine;

            StringReader reader = new StringReader(_testInput);
            StringBuilder builder = new StringBuilder();
            StringWriter writer = new StringWriter(builder);

            //<-- You may change the following 4 lines to adapt to your design.
            ReversePolishNotationCalculator calc = new ReversePolishNotationCalculator();
            CalculatorConsole cons=new CalculatorConsole(reader, writer, calc);
            CalculatorController contr = new CalculatorController(calc, cons);
            contr.StartViewNotification();
            cons.Run();
            //-->

            reader.Close();
            writer.Close();


            StringAssert.AreEqualIgnoringCase(_testOutput, builder.ToString(), "Fail");
		}

		[Test]
		public void TestMinus()
		{
            _testInput = "deutsch" + s_newLine
                    + "10" + s_newLine
                    + "5" + s_newLine
                    + "+" + s_newLine
                    + "auswerten" + s_newLine
                    + "drucken" + s_newLine
                    + "Hilfe" + s_newLine
                    + "english" + s_newLine
                    + "help" + s_newLine
                    + "quit" + s_newLine;
            _testOutput = "#Aktuelle Sprache: deutsch" + s_newLine
                    + "Befehle: loeschen, drucken, beenden, hilfe, auswerten" + s_newLine
                    + "#####15" + s_newLine
                    + "#Ungueltige Eingabe:" + s_newLine
                    + "\tHilfe" + s_newLine
                    + "#Current language: english" + s_newLine
                    + "Available commands: clear, print, quit, help, evaluate" + s_newLine
                    + "#Available commands: clear, print, quit, help, evaluate" + s_newLine
                    + "#Console calculator quitting..." + s_newLine;

            StringReader reader = new StringReader(_testInput);
            StringBuilder builder = new StringBuilder();
            StringWriter writer = new StringWriter(builder);

            //<-- You may change the following 4 lines to adapt to your design.
            ReversePolishNotationCalculator calc = new ReversePolishNotationCalculator();
            CalculatorConsole cons = new CalculatorConsole(reader, writer, calc);
            CalculatorController contr = new CalculatorController(calc, cons);
            contr.StartViewNotification();
            cons.Run();
            //-->

            reader.Close();
            writer.Close();

            StringAssert.AreEqualIgnoringCase(_testOutput, builder.ToString(), "Fail");
        }	
	}
}
